#include "crossroads.h"

int backend_available () {
    int i;
    
    /* Just see if all back ends are flagged down. In that case
     * we return 0.
     * We won't actually connect here with a back end, tcp_serve()
     * will do that later on.
     */

    for (i = 0; i < activeservice->nbackend; i++) {
	/* Backend i is available when:
	 * (a) The state indicates availability;
	 * (b) Either, there is no max to the active sessions, or
	 *     the # of sessions is below the max.
	 */
	if (servicereport->backendstate[i].avail == st_available &&
	    (activeservice->backend[i].maxclients == 0 ||
	     activeservice->backend[i].maxclients >
	     servicereport->backendstate[i].nclients))
	    msg ("Found (at least) one available back end\n");
	    return (1);
	}

    msg ("Found no available back end!\n");
    return (0);
}
