#include "crossroads.h"

/* Signal handler */
void interrupt (int sig) {
    interrupted++;
    
    switch (program_stage) {
    case stage_waiting:
	warning ("LISTENER: "
		 "Caught signal %d, freeing reporter and stopping\n",
		 sig);
	dealloc_reporter (activeservice);
	exit (1);
    case stage_serving:
	warning ("SESSION SERVICER: "
		 "Caught signal %d, will stop after servicing session\n",
		 sig);
	break;
    case stage_retrying:
	warning ("WAKEUP HANDER: "
		 " Caught signal %d, will stop waking up backend and exit\n",
		 sig);
	exit (1);
    default:
	msg ("Caught signal %d in program stage %d\n", sig, program_stage);
	exit (1);
    }
}
